#ifndef ANSI_HPP
#define ANSI_HPP

#include "Common.hpp"

enum
{
    Black        = 0x00,
    Red          = 0x01,
    Green        = 0x02,
    Brown        = 0x03,
    Blue         = 0x04,
    Magenta      = 0x05,
    Cyan         = 0x06,
    LightGray    = 0x07,
    DarkGray     = 0x08,
    LightRed     = 0x09,
    LightGreen   = 0x0a,
    Yellow       = 0x0b,
    LightBlue    = 0x0c,
    LightMagenta = 0x0d,
    LightCyan    = 0x0e,
    White        = 0x0f,
};

class AnsiImpl;

class Ansi
{
public:
    Ansi();
    Ansi(Ansi&& other);
    ~Ansi();
    Ansi& operator=(Ansi&& other);

    Ansi& changeColor(uint32_t fg, uint32_t bg, bool space = false);

    Ansi& clear(); // Clear screen and move cursor to top left
    Ansi& home(); // Move cursor to top left
    Ansi& erase(); // Erase to end of line

private:
    std::unique_ptr<AnsiImpl> m_pImpl;

private:
    Ansi(const Ansi& other) = delete;
    Ansi& operator=(const Ansi& other) = delete;
};

#endif
