#include "CalcScore.hpp"
#include "Problem.hpp"
#include "Solution.hpp"
#include "Game.hpp"
#include <algorithm>

using std::string;
using std::vector;

void calcScore(const Problem& problem,
               const vector<string>& phrases,
               uint32_t seed,
               const Solution& solution,
               uint64_t* pScore)
{
    Game game;
    game.init(problem, phrases, seed);

    vector<char> chars(solution.m_chars);
    chars.erase(std::remove(chars.begin(), chars.end(), '\t'),
                chars.end());
    chars.erase(std::remove(chars.begin(), chars.end(), '\n'),
                chars.end());
    chars.erase(std::remove(chars.begin(), chars.end(), '\r'),
                chars.end());
    size_t iChar = 0;
    while (iChar < chars.size() &&
           (!game.m_done || game.m_score != 0))
    {
        game.step(chars[iChar]);
        iChar++;
    }

    *pScore = game.m_score;
}
