#ifndef CELL_HPP
#define CELL_HPP

#include "Common.hpp"

class Cell
{
public:
    Cell() : m_x(0), m_y(0) {}
    Cell(int32_t x, int32_t y) : m_x(x), m_y(y) {}

    bool operator==(const Cell& other) const
    {
        return m_x == other.m_x && m_y == other.m_y;
    }
    bool operator!=(const Cell& other) const
    {
        return m_x != other.m_x || m_y != other.m_y;
    }

    bool operator<(const Cell& other) const
    {
        if (m_x != other.m_x)
        {
            return m_x < other.m_x;
        }
        return m_y < other.m_y;
    }

public:
    int32_t m_x;
    int32_t m_y;
};

#endif
