#include "Command.hpp"

bool charToCommand(char ch, Command* pCommand, bool* pIllegal)
{
    Command command = Command::E;
    if (!pCommand)
    {
        pCommand = &command;
    }

    bool bIllegal = false;
    if (!pIllegal)
    {
        pIllegal = &bIllegal;
    }

    switch (ch)
    {
    case 'p':
    case '\'':
    case '!':
    case '.':
    case '0':
    case '3':
        *pCommand = Command::W;
        *pIllegal = false;
        return true;

    case 'b':
    case 'c':
    case 'e':
    case 'f':
    case 'y':
    case '2':
        *pCommand = Command::E;
        *pIllegal = false;
        return true;

    case 'a':
    case 'g':
    case 'h':
    case 'i':
    case 'j':
    case '4':
        *pCommand = Command::SW;
        *pIllegal = false;
        return true;

    case 'l':
    case 'm':
    case 'n':
    case 'o':
    case ' ':
    case '5':
        *pCommand = Command::SE;
        *pIllegal = false;
        return true;

    case 'd':
    case 'q':
    case 'r':
    case 'v':
    case 'z':
    case '1':
        *pCommand = Command::CW;
        *pIllegal = false;
        return true;

    case 'k':
    case 's':
    case 't':
    case 'u':
    case 'w':
    case 'x':
        *pCommand = Command::CCW;
        *pIllegal = false;
        return true;

    case '\t':
    case '\n':
    case '\r':
        *pCommand = Command::E;
        *pIllegal = false;
        return false;

    default:
        *pCommand = Command::E;
        *pIllegal = true;
        return false;
    }
}

char commandToChar(Command command)
{
    switch (command)
    {
    case Command::E: return 'e';
    case Command::W: return '!';
    case Command::SE: return 'l';
    case Command::SW: return 'i';
    case Command::CW: return 'd';
    case Command::CCW: return 'k';
    default: return '\t';
    }
}
