#include "FileUtils.hpp"

using std::string;
using std::vector;

void readFile(FILE* f, vector<uint8_t>* pData)
{
    vector<uint8_t>& data = *pData;

    fseek(f, 0, SEEK_END);
    size_t size = (size_t)ftell(f);
    fseek(f, 0, SEEK_SET);

    data.resize(size);
    size_t pos = 0;
    while (pos < size)
    {
        size_t bytesRead = fread(&data[pos], 1, size - pos, f);
        if (bytesRead <= 0)
        {
            data.resize(pos);
            break;
        }
        pos += bytesRead;
    }
}

void getLines(const vector<uint8_t>& data, vector<string>* pLines)
{
    vector<string>& lines = *pLines;

    bool gotCR = false;
    bool newLine = true;

    size_t size = data.size();
    for (size_t i = 0; i < size; i++)
    {
        char ch = data[i];

        if (gotCR && ch == '\n')
        {
            gotCR = false;
            continue;
        }

        if (newLine)
        {
            lines.resize(lines.size() + 1);
            newLine = false;
        }

        string& line = lines.back();

        switch (ch) {
        case '\r':
            gotCR = true;
            newLine = true;
            break;
        case '\n':
            newLine = true;
            break;
        default:
            line.push_back(ch);
        }
    }
}

void readLines(FILE* f, vector<string>* pLines)
{
    vector<string>& lines = *pLines;

    bool gotCR = false;
    bool newLine = true;

    char buf[1024];
    while (!feof(f)) {
        size_t bytesRead = fread(buf, 1, 1024, f);
        for (size_t i = 0; i < bytesRead; i++)
        {
            char ch = buf[i];

            if (gotCR && ch == '\n')
            {
                gotCR = false;
                continue;
            }

            if (newLine)
            {
                lines.resize(lines.size() + 1);
                newLine = false;
            }

            string& line = lines.back();

            switch (ch) {
            case '\r':
                gotCR = true;
                newLine = true;
                break;
            case '\n':
                newLine = true;
                break;
            default:
                line.push_back(ch);
            }
        }
    }
}
