#ifndef GAME_HPP
#define GAME_HPP

#include "Common.hpp"
#include "Grid.hpp"
#include "Problem.hpp"
#include "Source.hpp"
#include "Command.hpp"

class Ansi;
class Move;

class Game
{
public:
    Game();

    void init(const Problem& problem,
              const std::vector<std::string>& phrases,
              uint32_t seed);
    bool isValid(const Unit& unit) const;
    void spawn();
    void step(char ch);
    void step(Command command);
    void move(const Move& move);
    void finishMove();

public:
    std::vector<std::string> m_phrases;
    std::vector<char> m_chars;
    std::vector<uint32_t> m_phraseCounts;
    Grid<uint32_t> m_grid;
    std::vector<Unit> m_units;
    Unit m_curUnit;
    bool m_done;
    uint64_t m_sourceLength;
    Source m_source;
    uint64_t m_spawnCount;
    uint64_t m_score;
    uint64_t m_linesOld;
};

void printGame(Ansi& ansi, const Game& game);

#endif
