#ifndef MOVES_HPP
#define MOVES_HPP

#include "Common.hpp"
#include "Unit.hpp"
#include "Move.hpp"
#include "Command.hpp"

class Game;

// Helper classes (implementation details)

class UnitRec
{
public:
    Unit m_unit;
    size_t m_prevUnit;
    Command m_command;
};

// Public interface

class MoveFinder
{
public:
    MoveFinder();

    void findMoves(const Game& game, std::vector<Move>* pMoves);
    void getCommands(const Move& move, std::vector<Command>* pCommands) const;

private:
    std::vector<UnitRec> m_units;
    std::vector<UnitRec> m_moves;
    typedef std::map<Unit, size_t> Index;
    Index m_unitIndex;
    Index m_moveIndex;
};


#endif
