#ifndef UNIT_HPP
#define UNIT_HPP

#include "Common.hpp"
#include "Cell.hpp"
#include <algorithm>

class Unit
{
public:
    bool operator<(const Unit& other) const
    {
        if (m_pivot != other.m_pivot)
        {
            return m_pivot < other.m_pivot;
        }
        if (m_members.size() != other.m_members.size())
        {
            return m_members.size() < other.m_members.size();
        }
        return std::lexicographical_compare(
            m_members.begin(), m_members.end(),
            other.m_members.begin(), other.m_members.end());
    }

public:
    std::vector<Cell> m_members;
    Cell m_pivot;
};

#endif
